#include "map/node.h"

#include "tiles/dirt.h"
#include "tiles/grass.h"
#include "tiles/stone.h"

Node::Node(const Node &other) {
    if(other.m_tile) m_tile = other.m_tile->clone();
    // if(other.m_entity) m_entity = other.m_entity->clone();

    m_pos = other.m_pos;
    m_size = other.m_size;
}

Node::~Node() {
    if(m_tile) delete m_tile;
    // if(m_entity) delete(m_entity);
}

void Node::render(Render r) {
    if(m_tile)
        m_tile->render(r, pos(), size());
}

std::ostream &operator<<(std::ostream &os, const Node &node) {
    os.write(reinterpret_cast<const char *>(&node.m_size), sizeof(node.m_size));

    if(node.m_tile) {
        os << '\x01';
        os << *node.m_tile;
    } else {
        os << '\x00';
    }

    return os;
}

std::istream &operator>>(std::istream &is, Node &node) {
    is.read(reinterpret_cast<char *>(&node.m_size), sizeof(node.m_size));

    uint8_t has_tile = 0;
    is.read(reinterpret_cast<char *>(&has_tile), sizeof(has_tile));
    if(has_tile) {
        int id = 0;
        // TODO: Move / figure this shit out
        is.read(reinterpret_cast<char *>(&id), sizeof(id));
        Tile *tile;
        switch(id) {
            case -1:
                tile = new Tile();
                break;
            case 1:
                tile = new Dirt();
                break;
            case 2:
                tile = new Grass();
                break;
            case 3:
                tile = new Stone();
            default:
                break;
        }
        if(tile) node.set_tile(tile);
        is >> *node.m_tile;
    }

    return is;
}
