#include "tiles/tile.h"

void Tile::render(Render r, Vector2<int>pos, Vector2<int>size) {
    r.rectangle_sz(
        pos * (TILE_SIZE + 1),
        size * TILE_SIZE,
        m_color
    );
}

std::ostream &operator<<(std::ostream &os, const Tile &tile) {
    os.write(reinterpret_cast<const char *>(&tile.m_id), sizeof(tile.m_id));
    os.write(reinterpret_cast<const char *>(&tile.m_color), sizeof(tile.m_color));

    return os;
}

std::istream &operator>>(std::istream &is, Tile &tile) {
    is.read(reinterpret_cast<char *>(&tile.m_color), sizeof(tile.m_color));

    return is;
}

