#pragma once

#include <iostream>

#include "util/render.h"
#include "util/vector2.h"

#define TILE_SIZE    16

class Tile {
    public:
        Tile() : Tile(-1) {}
        Tile(int id) : m_id(id) {}

        Tile(const Tile &other) = default;
        Tile &operator=(const Tile &other) = delete;

        virtual ~Tile() = default;

        virtual Tile *clone() { return new Tile(*this); }

        // Get the tile's ID
        int id() { return m_id; }
        // void set_id(int id) { m_id = id; }

        virtual void render(Render r, Vector2<int>pos, Vector2<int>size);

        friend std::ostream &operator<<(std::ostream &os, const Tile &tile);
        friend std::istream &operator>>(std::istream &is, Tile &tile);

    private:
        int m_id;
        Color m_color = Color::from_hsv(rand() % 255, 255, 255);
};
