#pragma once

#include "olcPixelGameEngine.h"
#include "util/color.h"
#include "util/vector2.h"

class Render {
    public:
        Render(olc::PixelGameEngine *pge) : m_pge(pge) {}

        void rectangle(Vector2<int> start, Vector2<int> end, Color color = {0, 0, 0});
        void rectangle_sz(Vector2<int> start, Vector2<int> size, Color color = {0, 0, 0});

        void fill_rectangle(Vector2<int> start, Vector2<int> end, Color color = {0, 0, 0});
        void fill_rectangle_sz(Vector2<int> start, Vector2<int> size, Color color = {0, 0, 0});

        void set_camera_pos(Vector2<int> camera_pos) { m_camera_pos = camera_pos; }
        Vector2<int> camera_pos() { return m_camera_pos; }

    private:
        olc::PixelGameEngine *m_pge;

        Vector2<int> m_camera_pos;
};
